/*!
 * @file hyperblast.h
 * @brief a Hyperblast Projectile
*/

#ifndef _HYPERBLAST_H
#define _HYPERBLAST_H

#include "projectile.h"

class Vector;
class Weapon;
class SpriteParticles;
class SparkParticles;
class ParticleEmitter;
class FastFactory;

class Hyperblast : public Projectile
{
  public:
    Hyperblast ();
    virtual ~Hyperblast ();


    virtual void activate();
    virtual void deactivate();

    virtual void collidesWith(WorldEntity* entity, const Vector& location);

    virtual void destroy ();

    virtual void tick (float time);
    virtual void draw () const;


  private:
    static FastFactory*               fastFactory;
    static SpriteParticles*           extParticles;
    static SparkParticles*            explosionParticles;

    ParticleEmitter*                  emitter;

    WorldEntity* hitEntity; // FIXME TEMPORARY
};

#endif /* _HYPERBLAST_H */
